import 'package:flavored_env/src/config.dart';
import 'package:flavored_env/src/models/env_var.dart';
import 'package:yaml/yaml.dart';

class Flavor {
  Flavor({
    required this.name,
    this.keys = const {},
    this.info = '',
  });

  factory Flavor.fromYamlMap(String name, YamlMap yamlMap) {
    assert(yamlMap.runtimeType == YamlMap, 'yamlMap is not a YamlMap object');

    final YamlMap keysMap = yamlMap[keysField] as YamlMap? ?? YamlMap();

    return Flavor(
      name: name,
      info: yamlMap[infoField] as String? ?? '',
      keys: Map.fromEntries(
        keysMap.entries.map((e) {
          return MapEntry(
            e.key as String,
            EnvVar.fromYamlMap(e.key as String, e.value as YamlMap?),
          );
        }).toList(),
      ),
    );
  }

  final String info;
  final Map<String, EnvVar> keys;
  final String name;
}
